/*
Here follows an example sketch for arduino which can be used as a first building block
The handshake byte sent over serial containing a char # is used to correct an error
which occurs from time to time when sending many bytes over serial. 
Author of this text is of course a genooius, geniouos, genious, ...ett geni...
but can still not explain exactly if this error is caused by packet loss or by magic
but the #-byte gets rid of the effects of the error.

Error description:
Byte array seems to be shifted 1 or a few bytes "sideways" making the buttons swap places
and mess up even the happiest of robots.

The code does this:
Lights the test LED if you move your cooliehat, the big green button.

UPDATE 2016!!!! 
Added example servo control
*/

#include <Servo.h> 

Servo myServo; // Create servo object

int nrBytes = 7;
char buff[7]; //declare how many bytes we are expecting
int ledPin = 13; 
int pos = 90; //create position integer


void setup(void) 
{ 
  pinMode(ledPin, OUTPUT);      // sets the digital pin as output  
  Serial.begin(9600);          //Set Baud Rate
  myServo.attach(5); //attach servo to pin 5
} 
void loop(void) 
{
  int chLeft = 4; //cooliehatUp
  int chRight = 2;
  if(Serial.available()){
    //the buffer to store the bytes in (char[] or byte[]), the number of bytes to read (int) 
    if(Serial.read() == '#'){
      
      if (Serial.readBytes(buff, nrBytes) > 0) { 


          if((buff[4]&chLeft)==chLeft && pos>10){ //if data received corresponding to specific buttonpress & position not exceeding limit, change value of integer
            pos = pos - 1;     
          }

          if((buff[4]&chRight)==chRight && pos<170){ //if data received corresponding to specific buttonpress & position not exceeding limit, change value of integer
            pos = pos + 1;           
          }

         myServo.write(pos); //move servo to position 

         
          if(buff[4]>0){
            digitalWrite(ledPin, HIGH);   // turn the LED on (HIGH is the voltage level)
            delay(10);               // wait for a second
            digitalWrite(ledPin, LOW);    // turn the LED off by making the voltage LOW
            delay(10);               // wait 10 ms
          }    
       }  
     } 
  }
}

